<template>
  <v-container>
    <v-row justify="center">
      <v-dialog
          v-model="dialogPost"
          fullscreen
          hide-overlay
          transition="dialog-bottom-transition"
          :retain-focus="false"
      >
        <template v-slot:activator="{ on, attrs }">
          <v-btn
              color="primary"
              dark
              v-bind="attrs"
              v-on="on"
          >
            Créer un Produit
          </v-btn>
        </template>
        <v-card>
          <v-toolbar
              dark
              color="primary"
          >
            <v-btn
                icon
                dark
                @click="dialogPost = false"
            >
              <v-icon>mdi-close</v-icon>
            </v-btn>
            <v-toolbar-title>Formulaire ajout Produit</v-toolbar-title>
            <v-spacer></v-spacer>
          </v-toolbar>
          <div>
            <v-card>
              <v-card-title>
                <span class="headline">Produit</span>
              </v-card-title>
              <v-card-text>
                <v-container>
                  <v-form>
                    <v-row>
                        <v-col cols="12">
                            <v-text-field
                                v-model="name"
                                label="Nom*"
                                type="text"
                                required
                            ></v-text-field>
                        </v-col>
                        <v-col cols="12">
                            <v-text-field
                                v-model="stock"
                                label="Stock*"
                                type="text"
                                required
                            ></v-text-field>
                        </v-col>
                        <v-col cols="12">
                            <v-text-field
                                v-model="image"
                                label="Image*"
                                type="text"
                                required
                            ></v-text-field>
                        </v-col>
                        <v-col cols="12">
                            <v-text-field
                                v-model="price"
                                label="price*"
                                type="text"
                                required
                            ></v-text-field>
                        </v-col>
                    </v-row>
                  </v-form>
                </v-container>
                <small>*L'étoile indique les champs requis</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn
                    color="blue darken-1"
                    text
                    @click="dialogPost = false"
                >
                  Fermer la fenêtre
                </v-btn>
                <v-btn
                    color="blue darken-1"
                    @click="dialogPost = false; postProduit();"
                >
                  Créer
                </v-btn>
              </v-card-actions>
            </v-card>
          </div>
        </v-card>
      </v-dialog>
    </v-row>
    <v-list>
      <v-list-item
          v-for="produit in produits"
          :key="produit.id"
      >
        <produit-component
            :id="produit.id"
            :name="produit.name"
            :stock="produit.stock"
            :image="produit.image"
            :price="produit.price"
            @updated="getProduits"
        />
      </v-list-item>
    </v-list>
  </v-container>
</template>

<script>
import ProduitComponent from "../components/ProduitComponent";

export default {
  name: "Produit",
  components: {ProduitComponent},
  data(){
    return {
      dialogPost: false,
      dialogPatch: false,
      produits: [],
      name: '',
      stock: '',
      id: '',
      image: '',
      price: '',
    }
  },
  mounted: function () {
    this.getProduits()
  },
  methods: {
    getProduits () {
        this.$axios.get('/produits', {
        })
          .then(response => {
            this.produits = response.data.map((produit) => {
              return {
                ...produit
              }
            })
          })
          .catch((erreur) => {
            console.log(erreur)
          })
      },

    postProduit() {
      this.$axios.post('/produits', {
        name: this.name,
        stock: this.stock,
        image: this.image,
        price: this.price,
      }).then((response) => {
        this.getProduits()
        this.name = response.data.msg
        this.stock = response.data.msg
        this.image = response.data.msg
        this.price = response.data.msg
      }).catch((erreur) => {
        console.log(erreur)
      })
    },
  }
}
</script>

<style scoped>

</style>